--Mammoth Strike Six

function mms_earthblitz_res()
IMG_earthblitz=ImageRessource("../data/gfx/units/earthblitz.png",1)

WorldPivot=GetWorldPivot()
SED_earthblitz_boost=LoadSED("../data/gfx/SED/Ships/Earthblitz.sed")
IMGSED_earthblitz_boost=LoadImage3D("../data/gfx/effects/Pixelated.png",2,5,WorldPivot,0)

SED_earthblitz_death=LoadSED("../data/gfx/SED/Deaths/EarthblitzExplosion.sed")
SED_earthblitz_charge=LoadSED("../data/gfx/SED/Projectiles/overcharged.sed")
IMGSED_earthblitz_charge=LoadImage3D("../data/gfx/effects/bolt.png",2,5,WorldPivot,0)

VAR_earthblitz_charge=0
VAR_earthblitz_chargeable=0
end

function mms_earthblitz_create(UnitID)
	UNIT_SetHP(UnitID,25)
	UNIT_SetSize(UnitID,1)
end

function mms_earthblitz_death(UnitID)
	UX=UNIT_GetX(UnitID)
	UY=UNIT_GetY(UnitID)
	for x=0,12,1 do
		DropSED(IMGSED_earthblitz_boost,SED_earthblitz_death,UX,UY,0,0,90,2*FNC_GetRandom(0,3,1),2)
		DropSED(IMGSED_earthblitz_boost,SED_earthblitz_death,UX,UY,0,0,-90,2*FNC_GetRandom(0,3,1),2)
		DropSED(IMGSED_earthblitz_boost,SED_earthblitz_death,UX,UY,0,0,180,2*FNC_GetRandom(0,3,1),2)
		DropSED(IMGSED_earthblitz_boost,SED_earthblitz_death,UX,UY,0,0,0,2*FNC_GetRandom(0,3,1),2)
	end
end

function mms_earthblitz_movement(UnitID)
	UX=UNIT_GetX(UnitID)/64
	UY=UNIT_GetY(UnitID)/64
	
	MAP_MarkMovementFieldCircle(UX,UY,4)
end 

function mms_earthblitz_attackrange(UnitID)
	UX=UNIT_GetX(UnitID)/64
	UY=UNIT_GetY(UnitID)/64
	MAP_MarkAttackFieldCircle(UX,UY,6,1,0,0)
end

function mms_earthblitz_update(UnitID)
UX=UNIT_GetX(UnitID)
UY=UNIT_GetY(UnitID)

SHIP_Angle=UNIT_GetAngle(UnitID)
--Draw main ship
DrawImage3D(IMG_earthblitz,UX,UY,0,SHIP_Angle,1,0)
--draw boost effects
DropSED(IMGSED_earthblitz_boost,SED_earthblitz_boost,UX+math.sin(math.rad(SHIP_Angle+180))*20,UY+math.cos(math.rad(SHIP_Angle+180))*20,0,0,SHIP_Angle+180,0.3,0.4)
end

function mms_earthblitz_move(UnitID)
UX=UNIT_GetX(UnitID)
UY=UNIT_GetY(UnitID)

TX=UNIT_GetTargetX()
TY=UNIT_GetTargetY()

--Angle=UNIT_GetAngle(UnitID)
Angle=math.deg(math.atan2(TX*64-UX,TY*64-UY))
UX=UX+math.sin(math.rad(Angle))*3
UY=UY+math.cos(math.rad(Angle))*3
UNIT_SetX(UnitID,UX)
UNIT_SetY(UnitID,UY)
UNIT_SetAngle(UnitID,Angle)


--stronger boost
DropSED(IMGSED_earthblitz_boost,SED_earthblitz_boost,UX+math.sin(math.rad(SHIP_Angle+180))*20,UY+math.cos(math.rad(SHIP_Angle+180))*20,0,0,SHIP_Angle+180,1,1)
end

function mms_earthblitz_attack(UnitID)
UX=UNIT_GetX(UnitID)
UY=UNIT_GetY(UnitID)

TX=UNIT_GetTargetX()
TY=UNIT_GetTargetY()

Angle=UNIT_GetAngle(UnitID)
Angle=Angle+(math.deg(math.atan2(TX*64-UX,TY*64-UY))-Angle)*0.05
UNIT_SetAngle(UnitID,Angle)

MSecs=GetMSecs()

if (math.deg(math.atan2(TX*64-UX,TY*64-UY))-Angle)<5 then
	if VAR_earthblitz_chargeable==0 then
		VAR_earthblitz_chargeable=1
		VAR_earthblitz_charge=MSecs
	end
	DropSED(IMGSED_earthblitz_charge,SED_earthblitz_charge,UX+math.sin(math.rad(SHIP_Angle))*20,UY+math.cos(math.rad(SHIP_Angle))*20,0,0,Angle+FNC_GetRandom(-180,180,1),0.5*((MSecs-VAR_earthblitz_charge)/500),0.6)
	if MSecs-VAR_earthblitz_charge>300 then
		PRJ_CreateProjectile("chainlightning",UX,UY,Angle,TX,TY)
		Shatter(0.2)
		VAR_earthblitz_chargeable=VAR_earthblitz_chargeable+1
		VAR_earthblitz_charge=MSecs
	end
	if VAR_earthblitz_chargeable==4 then
		UNIT_StopAttacking()
		VAR_earthblitz_chargeable=0
	end
end
end

function mms_earthblitz_event(UnitID)
	if UNIT_GetEvent(UnitID,2)~="" then--hat schaden erlitten
		UX=UNIT_GetX(UnitID)
		UY=UNIT_GetY(UnitID)
		if FNC_GetRandom(1,5,0)==1 then PRJ_CreateProjectile("chainlightning",UX,UY,Angle,UX/64+1,UY/64) end
		if FNC_GetRandom(1,5,0)==1 then PRJ_CreateProjectile("chainlightning",UX,UY,Angle,UX/64-1,UY/64) end
		if FNC_GetRandom(1,5,0)==1 then PRJ_CreateProjectile("chainlightning",UX,UY,Angle,UX/64,UY/64-1) end
		if FNC_GetRandom(1,5,0)==1 then PRJ_CreateProjectile("chainlightning",UX,UY,Angle,UX/64,UY/64+1) end
	end
end